<?php

namespace Teknisa\MAN\Controllers;

use Teknisa\MAN\Services;
use Zeedhi\Framework\DTO;
use Teknisa\MAN\Utilities;
use \Setforms2\Shared\ORM\DateTime;
use Zeedhi\Framework\DataSource\DataSet;

class AjustaSaldoMensalConsumidor {
    
    protected $dataSourceName = 'vnd48000_ajustasaldomensal';
    protected $service;
    protected $utilService;
    const CDCLIENTE = 'CDCLIENTE';
    const CDFILIAL = 'CDFILIAL';
    const DATA = 'DATA';
    
    public function __construct (Utilities\Util $utilService, Services\AjustaSaldoMensalConsumidor $service){
        $this->service = $service;
        $this->utilService = $utilService;
    }
    
    public function ajustar(DTO\Request\Row $request, DTO\Response $response){
        $conditions = $this->utilService->getParamsAsArray($request);
        $conditions  = $this->buildCdCliente($conditions);
        $conditions  = $this->buildCdFilial($conditions);
       //$conditions = $this->buildData($conditions);
        try{
            $retorno = $this->service->ajustar($conditions);
            $response->addDataset(new DataSet($this->dataSourceName,array('response'=>$retorno)));
        }catch(\Exception $e){
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
    
    private function buildCdCliente ($conditions){
        if(!array_key_exists(self::CDCLIENTE, $conditions) || !count($conditions[self::CDCLIENTE])) {
            $conditions[self::CDCLIENTE] = 'T';
        }else{
            $conditions[self::CDCLIENTE] = '_'.implode('_', $conditions[self::CDCLIENTE]);
        }
        
        return $conditions;
    }
    
    /*private function buildData ($conditions){
        
        if(!array_key_exists(self::DATA, $conditions) || !count($conditions[self::DATA]) || empty($conditions[self::DATA])) {
            $conditions[self::DATA] = $this->retornarDataAtual();
        }
        
        return $conditions;
    }*/
    
    private function retornarDataAtual(){
        $date = new DateTime();
        $data = explode(' ',$date);
        return $data[0];
        
    }
    
    private function buildCdFilial ($conditions){
        if(is_array($conditions[self::CDFILIAL])){
            $conditions[self::CDFILIAL] = $conditions[self::CDFILIAL][0];
        }
        return $conditions;
    }
}