<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class RelSinteseFaturamento  {

    protected $relSinteseFaturamento;
    protected $utilService;
    
    public function __construct(Services\RelSinteseFaturamento $relSinteseFaturamento, Utilities\Util $utilService) {
        $this->relSinteseFaturamento = $relSinteseFaturamento;
        $this->utilService = $utilService;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        
        $conditions = $this->utilService->getParamsAsArray($request);
        $modalidades = 'MES_BAL_DLV_TAA_CMD_AJU_AUT';
        if($conditions['RELATORIO'] == 'GERAL') {

            $conditions = $this->relSinteseFaturamento->buildParamsFaturamento($conditions, $modalidades);
            
            if($conditions['TIPORELATORIO'] == 'A' || $conditions['TIPORELATORIO'] == 'D') {
                $result = $this->relSinteseFaturamento->find($conditions['CDFILIAL'], $conditions['CDLOJA'], $conditions['TCDLOJA'], $conditions['DATAINI'], $conditions['DATAFIN'], $conditions['MODALIDADE'], $conditions['NRORG']);
                
            } else if($conditions['TIPORELATORIO'] == 'S'){
                $result = $this->relSinteseFaturamento->findSintetico($conditions['CDFILIAL'], $conditions['CDLOJA'], $conditions['TCDLOJA'], $conditions['DATAINI'], $conditions['DATAFIN'], $conditions['MODALIDADE'], $conditions['NRORG']);
            }

            $response->addDataSet(new DataSet("vnd55002_relSinteseFaturamento", $result));
            
            return $response;
        } else if($conditions['RELATORIO'] == 'DIA') {

            $conditions = $this->relSinteseFaturamento->buildParamsFaturamento($conditions, $modalidades);
            
            if($conditions['TIPORELATORIO'] == 'A' || $conditions['TIPORELATORIO'] == 'D') {
                $result = $this->relSinteseFaturamento->findDia($conditions['CDFILIAL'], $conditions['CDLOJA'], $conditions['TCDLOJA'], $conditions['DATAINI'], $conditions['DATAFIN'], $conditions['MODALIDADE'], $conditions['NRORG']);
            } else if($conditions['TIPORELATORIO'] == 'S'){
                $result = $this->relSinteseFaturamento->findDiaSintetico($conditions['CDFILIAL'], $conditions['CDLOJA'], $conditions['TCDLOJA'], $conditions['DATAINI'], $conditions['DATAFIN'], $conditions['MODALIDADE'], $conditions['NRORG']);
            }
            if($result) {
                $result = $this->relSinteseFaturamento->reorderResultsbyDate($result);
            }
            
            $response->addDataSet(new DataSet("vnd55003_relSinteseFaturamentoDia", $result));
            return $response;
        }
    }
}
